<?php

/**
 * @author Bettina Schwarzer, Fritz-Haber-Institut
 * @copyright 04/2012
 * 
 * Liste Vertragsdaten mit Sortierung
 */

    error_reporting(E_ALL ^ E_NOTICE);
    
    session_start();
    if (! isset($_SESSION["userid"]))
    { 
        include_once ("inc/func_lib.inc.php");	
        login("vertrag_flist2.php");
        exit;
    }
    
    if (is_null($_SESSION["recht"]) || (!is_null($_SESSION["recht"]) && !in_array("vr",$_SESSION["recht"]) && !in_array("ve",$_SESSION["recht"])))
    {
        header("Location: start.php");
        exit;
    }    
    
?>
    
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
   	<link href="css/db.css" rel="STYLESHEET" type="TEXT/CSS" media="screen "/> 
   	<link href="css/db_print.css" rel="STYLESHEET" type="TEXT/CSS" media="print" /> 

	<title>Liste Vertragsdaten, Teil 2</title>
</head>

<body>

<?php
    echo "&nbsp;";  
    echo "<div class=\"float-br smaller\" valign='top'>";
    echo "&nbsp;&nbsp;&nbsp;user: " . $_SESSION["userid"];
    echo "&nbsp;&nbsp;&nbsp;<a class='sc' href='/fhiiqm/logout.php' title='Session beenden'>logout</a></div>\n";
    echo "<div class=\"float-r\">&nbsp;&nbsp;&nbsp;<img src=\"img/document_mark_as_final.png\" border=\"0\" alt=\"Vertr&auml;ge\" title=\"Vertr&auml;ge\"/></div>\n";

    $zeil = $_GET["z"];
    if (!$zeil) $zeil = 25; // Anzahl der gezeigten Zeilen
    $start = $_GET["st"];   // Start bei DS $start+1
    if (!$start) $start=0;
    
    // Felder, nach denen gefiltert werden kann
    $fields = array(2=>"Bezeichnung",4=>"Bearbeiter",6=>"Vertragstyp",7=>"Produkt",8=>"Partner");

	$sort   = $_GET["s"];   // Sortierung nach Spalte
    $dir    = $_GET["d"];   // Sortierrichtung
    if (!isset($sort) || !$sort) $sort = 2;
    if (!isset($dir) || !$dir)  $dir = "";

    $fnum   = $_GET["f"];   // Spaltennummer, nach der aktuell gefiltert wird
    $filter = $_GET["b"];   // Filterbegriff
    $mfile  = $_GET["g"];   // Multifile = mehrere Vertragsdokumente moeglich
    if (!isset($fnum) || !$fnum) $fnum = 0;
    // $_GET-Parameter zurueck zur Vertragliste mit den selben Einstellungen wie zuvor fuer Update
    $getp = "s=$sort&d=$dir&f=$fnum&b=$filter&st=$start&z=$zeil&g=$mfile&t=2"; 
    
    $listg  = $_GET["l"];
    if (!isset($listg) || !$listg)
    {
        // Recht Produktgruppe beruecksichtigen
        if (is_array($_SESSION["prodg"]))
        {
                foreach ($_SESSION["prodg"] as $val)
                    $listg .= "," .$val;
                $listg = substr($listg,1);
        }
        else $listg = "";
    }

    include_once($_SERVER['DOCUMENT_ROOT'] ."/fhiiqm/inc/dbconnect.inc.php");
    include_once ($_SERVER['DOCUMENT_ROOT'] ."/fhiiqm/inc/func_lib.inc.php");
	$dbc = new dbconnection();

    if ($mfile)
        $sql = "CALL fhiiqm.vertrag_flist12_mf(" . $sort . ",'" . $dir . "', " . $fnum . ", '" . $filter . "', '" . $listg . "',$start,$zeil, @anz, @ganz)";
    else
        $sql = "CALL fhiiqm.vertrag_flist12(" . $sort . ",'" . $dir . "', " . $fnum . ", '" . $filter . "', '" . $listg . "',$start,$zeil, @anz, @ganz)";
    // Parameter: Nr. Sortfelf, Sortierrichtung, Nr. Filterfeld, Filterbegriff, Start bei DS $start+1, Anzahl DS/Seite, Anzahl gefundener Vertraege, Anzahl DS gesamt
    // liefert Felder: contract_ID,cname,clong,bearb,doc,typ,prod,cbegin,cend,kmon,partfirmar,kyear,kosten,bem
    $result = $dbc -> queryObjectArray($sql);
    if ($result)
    {
		$bg1 = "#F8F8F8";
		$bg2 = "#DEDFE1";
		$bg = "#FFFFFF";
        
        $heute = new DateTime();
        
        $vanz = $dbc -> querySingleItem("SELECT @anz");
        $ganz = $dbc -> querySingleItem("SELECT @ganz");
        
        echo "<div align='center'>\n";
        echo "<p><b>Vertr&auml;ge Teil 2</b></p>\n";
        echo "<table border='0' cellspacing='0'>\n";
        echo "<tr><td class='bigger'>Mittels '<img src='img/auf.gif' border='0' width='9' hight='9'>' / '<img src='img/ab.gif' border='0' width='9' hight='9'>' 
            knnen Sie Spalten auf- bzw. absteigend sortieren</td></tr>
            <tr><td class='bigger'>Klick auf '<img src='img/edit.gif' border='0' width='11' hight='11'>' - Bearbeiten der Vertragsdaten</td></tr>\n";
        echo "</table>\n";
        printf ("<p>Anzahl Vertr&auml;ge: %s </p>", $vanz);
        echo "<table width='99%'>\n";

        if ($filter>'!') echo "<tr><td class='bigger' colspan=7>Filter: ". $fields["$fnum"] . " wie '$filter'</td><tr>\n";

        echo "<tr bgcolor='#68ACBF'>";
        tab_column(8,"Partner",$sort,$dir,0,$fnum,$filter,$start,$zeil);
        tab_column(2,"Bezeichnung",$sort,$dir,0,$fnum,$filter,$start,$zeil);
        tab_column(9,"Beginn",$sort,$dir,0,$fnum,$filter,$start,$zeil);
        tab_column(10,"Ende",$sort,$dir,0,$fnum,$filter,$start,$zeil);
        tab_column(11,"Verl&auml;ng.",$sort,$dir,0,$fnum,$filter,$start,$zeil);
        tab_column(12,"K&uuml;nd.frist (mon)",$sort,$dir,0,$fnum,$filter,$start,$zeil);
        echo "<th>Kosten/Jahr(&euro;)</th>";
        echo "<th>Bemerkung</th>";
        echo "<th>E-Mail</th>";

        echo "<th>&nbsp;</th></tr>\n";
        foreach ($result as $row)
        {
            // Anzeigen der nur einmal relevanten Daten
			if ($bg == $bg1) $bg = $bg2; else $bg = $bg1;
            if ($row->cend)
            {
                $ce = new DateTime($row->cend);
                if ((!$row->cautoend || is_null($row->cautoend)) && $heute > $ce) $class="class='red'"; else $class="";
            }
            else $class="";
            echo "<tr bgcolor='" . $bg . "'>"; 
            echo "<td>$row->partfirma</td>";
            echo "<td $class><b>$row->cname</b></td>";    
//            echo "<td>$row->contract_s</td>";    
            if ($row->cbegin)
            {
                $cb = new DateTime($row->cbegin);    
                echo "<td>" . $cb->format('d.m.Y')."</td>";
            }
            else  echo "<td>&nbsp;</td>";       
            if ($row->cend)
                echo "<td>" . $ce->format('d.m.Y')."</td>";    
            else  echo "<td>&nbsp;</td>";       
            if ($row->cautoend) echo "<td>automatisch</td>"; else echo "<td>&nbsp;</td>"; 
            echo "<td class='center'>$row->kmon</td>";    
        
            // Anzeigen Kosten pro Jahr -> 1 Zeile des Resultsets (Kosten fast rechtsbuendig!))
            if ($row->yearkosten)   // Form: yyyy:nnn.nn|yyyy:nnnnn|yyyy:nn.n usw.
            { 
                $yka = explode('|',$row->yearkosten);   
                $first = true;
                foreach ($yka as $yk)
                {
                    if (!$first) echo "<br />"; else echo "<td>"; 
                    list($year,$kost) = explode(':',$yk);                    
                    echo "$year:&nbsp;&nbsp;&nbsp;" . str_replace(" ","&nbsp;",sprintf("%' 10s",number_format($kost,2,",","."))) . "";
                    $first = false;
                }
                echo "</td>";
            }
            else echo "<td>&nbsp;</td>";    
            $mail = ($row->email)? "ja": "&nbsp;";   
            echo "<td width='27%'>".nl2br($row->bem)."</td>";    
            echo "<td>$mail</td>";
            if ($mfile) $part = "ed"; else $part = "upd";
            echo "<td><a href='vertrag_$part.php?uid=$row->contract_ID&$getp'><img src=\"img/edit.gif\" alt='edit' title='edit' border='0'/></a></td></tr>\n";
       }
        echo "</table></div>\n";
        echo "<br />&nbsp;&nbsp;&nbsp;";
        
        // Sortierung und Filter aus $_GET fuer weitere Seiten
        foreach ($_GET as $key=>$val)
        {
            if ($key != "st") $liste .= "&" . $key ."=".$val;
        }    
        // Sortierung und Filter aus $_POST fuer weitere Seiten
        if ($subf)
        foreach ($_POST as $key=>$val)
        {
            if ($key != "st" && $key != "subf" && $key != "filter") $liste .= "&" . $key ."=".$val;
            if ($key == "filter") $liste .= "&b=" . $val;
        }    
        
        // Links auf andere Seiten generieren
        liste_links($start,$zeil,$ganz,$liste);
    }
    else
    {
        print_r ($dbc -> error);
    }
    $dbc -> close();
    if (!is_null($_SESSION["recht"]) && in_array("ve",$_SESSION["recht"]))
    {
        if ($mfile)
            echo "<p>&nbsp;&nbsp;&nbsp;<a href=\"/fhiiqm/vertrag_ed.php?$getp\" target=\"_self\" class=\"sc\" title=\"Vertrag erfassen\">Weiteren Vertrag erfassen</a></p>\n";    
        else
            echo "<p>&nbsp;&nbsp;&nbsp;<a href=\"/fhiiqm/vertrag_ins.php\" target=\"_self\" class=\"sc\" title=\"Vertrag erfassen\">Weiteren Vertrag erfassen</a></p>\n";    
    }

?>
</body>
</html>